#!/bin/bash

# First, load the example API
. ./Iper_API.sh

# Then, define your API key, your API secret, and select the API response format 
APIKEY=123456789abcdef0123456789abcdef0
APISECRET=123456789abcdef0
APIFORMAT=json

if [ $APIKEY = 123456789abcdef0123456789abcdef0 -o $APISECRET = 123456789abcdef0 ]; then
  echo "error: please, edit this script to define your API key and secret..."
  exit 1
fi

# You need the user to grant you the necessary permissions:

echo
echo "### Get a temporary FROB from ipernity"
JSON_STRING=`call_api_method $APIKEY $APISECRET $APIFORMAT auth.getFrob`
echo "JSON = $JSON_STRING"
FROB=`echo "$JSON_STRING" | tr "\"" " " | awk ' { print $6 } '`
echo "FROB = $FROB"
echo

echo "### Ask the user to go to ipernity and grant permissions to the FROB owner (you)"
echo "Goto "`get_user_auth $APIKEY $APISECRET $FROB perm_doc=write perm_blog=write`
echo "and grant the permissions, then press <ENTER>"
read LINE

echo "### Exchange the temporary FROB for a definitive TOKEN"
JSON_STRING=`call_api_method $APIKEY $APISECRET $APIFORMAT auth.getToken frob=$FROB`
echo "JSON = $JSON_STRING"
TOKEN=`echo "$JSON_STRING" | tr "\"" " " | awk ' { print $6 } '`
echo "TOKEN = $TOKEN"
echo

# Now, with this TOKEN, you are ready to make authenticated queries
# You will only need to redo the 3 previous steps if you lose this TOKEN,
# if you need different permissions, or if the user revoked your application.

echo "### Let's check our TOKEN"
JSON_STRING=`call_api_method $APIKEY $APISECRET $APIFORMAT auth.checkToken auth_token=$TOKEN`
echo "JSON = $JSON_STRING"
echo

# Here are some more examples...
#call_api_method $APIKEY $APISECRET $APIFORMAT account.getQuota auth_token=$TOKEN
#call_api_method $APIKEY $APISECRET $APIFORMAT doc.tags.add auth_token=$TOKEN doc_id=123456 keywords=black,white
#call_api_method $APIKEY $APISECRET $APIFORMAT doc.comments.add auth_token=$TOKEN doc_id=123456 content="This is a comment"
#call_api_method $APIKEY $APISECRET $APIFORMAT doc.comments.add auth_token=$TOKEN doc_id=123456 content="This is another comment"
#call_api_method $APIKEY $APISECRET $APIFORMAT doc.comments.add auth_token=$TOKEN doc_id=123456 content="This is a third comment"
#call_api_method $APIKEY $APISECRET $APIFORMAT doc.comments.delete auth_token=$TOKEN doc_id=123456 comment_id=1234
#call_api_method $APIKEY $APISECRET $APIFORMAT doc.set auth_token=$TOKEN doc_id=123456 title="Hello" description="Hello World"
#call_api_method $APIKEY $APISECRET $APIFORMAT doc.get auth_token=$TOKEN doc_id=123456 extra=tags,notes,geo
#call_api_method $APIKEY $APISECRET $APIFORMAT doc.getPerms auth_token=$TOKEN doc_id=123456
#call_api_method $APIKEY $APISECRET $APIFORMAT doc.comments.getList auth_token=$TOKEN doc_id=123456
#call_api_method $APIKEY $APISECRET $APIFORMAT upload.file auth_token=$TOKEN file=acme.png
